import java.util.ArrayList;

public class UBLCSS {
	static double LCSS(ArrayList<Double> serverTraj, ArrayList<Double> clientTraj) {

		// PHASE 1
		// Initialize first column and row to assist the DP Table
		double[][] L = new double[clientTraj.size() + 1][serverTraj.size() + 1];
		int k, l;

		for (int i = 1; i < clientTraj.size() + 1; i++) {
			for (int j = 1; j < serverTraj.size() + 1; j++) {
				if (clientTraj.get(i - 1).equals(serverTraj.get(j - 1)))
					L[i][j] = L[i - 1][j - 1] + 1;
				else
					L[i][j] = Math.max(L[i - 1][j], L[i][j - 1]);
			}
		}
		// PHASE 2
		k = clientTraj.size();
		l = serverTraj.size();

		while (true) {
			if ((k == 0) || (l == 0))
				break;

			// Match
			if (clientTraj.get(k - 1).equals(serverTraj.get(l - 1))) {
				// Move to L[i-1][j-1] in next round
				k--;
				l--;

			} else {
				// Move to max { L[k][l-1],L[k-1][l] } in next round
				if (L[k][l - 1] >= L[k - 1][l])
					l--;
				else
					k--;

			}

		}
		return (L[clientTraj.size()][serverTraj.size()]/(double)(Math.min(clientTraj.size(),serverTraj.size())) *100);
	}
}
